# perl interface for jags (just another Gibbs sampler)
# '17/07/05 by KGK

# base of convergence diagnostic
package Makeshift::Jags::coda::convergence;

use Carp::Assert;
use Mouse;

has 'method' => (is => 'ro');
has 'args' => (is => 'rw', default => sub{{}});
has 'names'  => (is => 'rw', default => sub{[]});
has 'value' => (is => 'rw', default => sub{{}});

__PACKAGE__->meta->make_immutable();

# R_line(coda_obj): full command line for R
# coda_obj: mcmc object stored coda
sub R_line {
	my $self = shift;
	my $coda = shift;
	my $ret = $self->method . ".diag($coda";

	for (keys %{$self->args}) {
		$ret .= ", $_ = " . $self->args->{$_};
	}
	$ret .= ")";

	return $ret;
}

# read_log(file): read logfile and store result of monitored variables
# file: log_file
sub read_log {
	assert(1, "to be overrided");
}

# ok(val): convergence check for each parameter
# val: value of convergence diagnostic
# return value -> bool (OK/NG)
sub ok {
	assert(1, "to be overrided");

	return 0;
}

# check: convergence check for all parameters
sub check {
	my $self = shift;
	my $ret = 1;

	for my $var (@{$self->names}) {
		$ret &&= $self->ok($self->value->{$var});
	}

	return $ret;
}

#__PACKAGE__->meta->make_immutable();

1;
# end
