# perl interface for jags (just another Gibbs sampler)
# '17/07/05 by KGK

# variable in jags
package Makeshift::Jags::var;

use Carp::Assert;
use Mouse;

has 'name' => (is => 'ro', required => 1);
has 'type' => (is => 'rw', default => "scalar");
has 'value' => (is => 'rw', predicate => 'has_value');

__PACKAGE__->meta->make_immutable();

# BUILD: called by constructor
sub BUILD {
    my $self = shift;

#	print join(", ", @{$self->value}), "\n";

	$self->set($self->value) if $self->has_value;
}

# set(value): name <- value
sub set {
    my $self = shift;
	my $val = shift;

	assert(defined $val, "value of \'" . $self->name . "\' must be specified");

	$self->type("vector") if ref $val;
	$self->value($val);

	return $self;
}

# Rstyle: R-style strings "name <- value"
sub Rstyle {
    my $self = shift;
	my $ret = $self->name . " <- ";

	if ($self->type eq "vector") {
#		print $self->name, ": ", $self->value, "; ", join(", ", @{$self->value}), "\n";
		$ret .= "c(" . join(", ", @{$self->value}) . ")";
	} else {
		$ret .= $self->value;
	}

	return $ret;
}

#__PACKAGE__->meta->make_immutable();

1;
# end
