#!/usr/bin/perl

# from http://uca-works.com/stat/RJAGS/JAGS_begin/jags.pdf

use Makeshift::Jags;

my $jags = Makeshift::Jags->new;
#my $jags = Makeshift::Jags->new(CLEANUP => 0);
my $n = $jags->read_csv("regdata.csv");

$jags->data->set(N => $n, K => 2);
$jags->param->set(alpha => [1, 1], tau => 1);

$jags->model_file("reg_model.jag");
$jags->set_monitor("sigma2");
$jags->del_monitor("tau");

$jags->burnin(1000);
$jags->update(5000);

#print @{$jags->script};

$jags->run;

my $coda = $jags->coda->[1];

$coda->diag_method("geweke");
$coda->summary;

# Graph
# use PDL;
# use PDL::Graphics::Gnuplot;
# my $a1 = $coda->mean->{"alpha[1]"};
# my $a2 = $coda->mean->{"alpha[2]"};
# my $x = pdl($jags->data->get("x")->{value});
# my $y = pdl($jags->data->get("y")->{value});
# my $s = sqrt($coda->mean->{"sigma2"});
# my $z = $a1 + $a2 * $x;
# my $zl = $z - $s;
# my $zh = $z + $s;

# my $graph = gpwin();
# $graph->plot(with => 'points', $x, $y, with => 'lines', $x, $z,
# 			 with => 'lines', $x, $zl, with => 'lines', $x, $zh);
# $graph->read_mouse();
# save graph
# # $graph->plot(hardcopy => 'test.png',
# # 			 with => 'points', $x, $y, with => 'lines', $x, $z,
# # 			 with => 'lines', $x, $zl, with => 'lines', $x, $zh);

# end of script
